package com.bookcollector.controller;

import java.io.IOException;
import javax.servlet.ServletException;
import javax.servlet.annotation.WebServlet;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import com.bookcollector.model.Book;
import com.bookcollector.model.dao.AuthorDAO;
import com.bookcollector.model.dao.BookDAO;
import com.bookcollector.model.dao.CategoryDAO;
import com.bookcollector.model.dao.PublisherDAO;

@WebServlet("/add")
public class AddController extends HttpServlet {
	private static final long serialVersionUID = 1L;

	protected void doGet(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
	}

	protected void doPost(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
		String asa = request.getParameter("asa");
		switch (asa) {
		case "publisher":
			String name = request.getParameter("name");
			if(new PublisherDAO().addPublisher(name)){
				request.getRequestDispatcher("publishers.jsp").forward(request, response);
			}
			/*
			 * BUG: Turkish characters
			 */
			break;
		case "category":
			name = request.getParameter("name");
			if(new CategoryDAO().addCategory(name)){
				request.getRequestDispatcher("categories.jsp").forward(request, response);
			}
			break;
		case "author":
			String firstname = request.getParameter("firstname");
			String surname = request.getParameter("surname");
			if(new AuthorDAO().addAuthor(firstname, surname)){
				request.getRequestDispatcher("authors.jsp").forward(request, response);
			}
			break;
		case "book":
			name = request.getParameter("name");
			int totalPages = Integer.valueOf(request.getParameter("totalPages"));
			long ISBN = Long.valueOf(request.getParameter("ISBN"));
			int publisher = Integer.valueOf(request.getParameter("publisher"));
			int author = Integer.valueOf(request.getParameter("author"));
			int category = Integer.valueOf(request.getParameter("category"));
			Book book = new Book(new CategoryDAO().getCategory(category), new AuthorDAO().getAuthor(author), 
					new PublisherDAO().getPublisher(publisher), ISBN, totalPages, name);
			request.setAttribute("book", book);
			if(new BookDAO().addBook(book)){
				request.getRequestDispatcher("books.jsp").forward(request, response);
			}
			break;
		}
	}

}