package com.bookcollector.controller;

import java.io.IOException;
import javax.servlet.ServletException;
import javax.servlet.annotation.WebServlet;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import com.bookcollector.model.Author;
import com.bookcollector.model.Book;
import com.bookcollector.model.Category;
import com.bookcollector.model.Publisher;
import com.bookcollector.model.dao.AuthorDAO;
import com.bookcollector.model.dao.BookDAO;
import com.bookcollector.model.dao.CategoryDAO;
import com.bookcollector.model.dao.PublisherDAO;

@WebServlet("/update")
public class UpdateController extends HttpServlet {
	private static final long serialVersionUID = 1L;

	protected void doGet(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
		String asa = request.getParameter("asa");
		int id = Integer.valueOf(request.getParameter("id"));
		request.setAttribute("id", id);
		switch (asa) {
		case "book":
			request.getRequestDispatcher("updatebook.jsp").forward(request, response);
			break;
		case "author":
			request.getRequestDispatcher("updateauthor.jsp").forward(request, response);
			break;
		case "category":
			request.getRequestDispatcher("updatecategory.jsp").forward(request, response);
			break;
		case "publisher":
			request.getRequestDispatcher("updatepublisher.jsp").forward(request, response);
			break;
		}
	}
	
	protected void doPost(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
		String asa = request.getParameter("asa");
		switch (asa) {
		case "book":
			int id = Integer.valueOf(request.getParameter("id"));
			String name = request.getParameter("name");
			int totalPages = Integer.valueOf(request.getParameter("totalPages"));
			long ISBN = Long.valueOf(request.getParameter("ISBN"));
			int publisher = Integer.valueOf(request.getParameter("publisher"));
			int author = Integer.valueOf(request.getParameter("author"));
			int category = Integer.valueOf(request.getParameter("category"));
			Book book = new Book(id,new CategoryDAO().getCategory(category), new AuthorDAO().getAuthor(author), 
					new PublisherDAO().getPublisher(publisher), ISBN, totalPages, name);
			if(new BookDAO().updateBook(book)){
				request.getRequestDispatcher("books.jsp").forward(request, response);
			}
			break;
		case "author":
			id = Integer.valueOf(request.getParameter("id"));
			String firstname = request.getParameter("firstname");
			String surname = request.getParameter("surname");
			Author _author = new Author(id, firstname, surname);
			if(new AuthorDAO().updateAuthor(_author)){
				request.getRequestDispatcher("authors.jsp").forward(request, response);
			}
			break;
		case "category":
			id = Integer.valueOf(request.getParameter("id"));
			name = request.getParameter("name");
			Category _category = new Category(id, name);
			if(new CategoryDAO().updateCategory(_category)){
				request.getRequestDispatcher("categories.jsp").forward(request, response);
			}
			break;
		case "publisher":
			id = Integer.valueOf(request.getParameter("id"));
			name = request.getParameter("name");
			Publisher _publisher = new Publisher(id, name);
			if(new PublisherDAO().updatePublisher(_publisher)){
				request.getRequestDispatcher("publishers.jsp").forward(request, response);
			}
		}
	}

}