package com.bookcollector.model.dao;

import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.ArrayList;

import com.bookcollector.model.Author;
import com.bookcollector.tool.ConnectionManager;

public class AuthorDAO {
	Connection conn = ConnectionManager.getConnection();
	
	public Author getAuthor(int idAuthor){
		
		String query = "SELECT * FROM Author WHERE idAuthor=?";
		Author author = null;
		
		try {
			PreparedStatement psmt = conn.prepareStatement(query);
			psmt.setInt(1, idAuthor);
			ResultSet rs = psmt.executeQuery();
			while(rs.next()){
				author = new Author(idAuthor, rs.getString("firstname"), rs.getString("surname"));
			}
		} catch (SQLException ex) {
			ex.printStackTrace();
		}
		return author;
	}
	
	public boolean addAuthor(String firstname, String surname){
		String query = "INSERT INTO Author VALUES (DEFAULT, ?, ?)";
		
		try{
			PreparedStatement psmt = conn.prepareStatement(query);
			psmt.setString(1, firstname);
			psmt.setString(2, surname);
			psmt.executeUpdate();
		}catch(SQLException ex){
			ex.printStackTrace();
		}
		
		return true;
	}
	
	public ArrayList<Author> getAllAuthors(){
		ArrayList<Author> authors = new ArrayList<>();
		
		
		String query = "SELECT * FROM Author";
		
		try {
			PreparedStatement psmt = conn.prepareStatement(query);
			ResultSet rs = psmt.executeQuery();
			while(rs.next()){
				Author author = new AuthorDAO().getAuthor(rs.getInt("idAuthor"));
				authors.add(author);
			}
		} catch (SQLException ex) {
			ex.printStackTrace();
		}
		return authors;
	}
	
	public boolean deleteAuthor(int id){
		String query = "DELETE FROM Author WHERE idAuthor=?";
		
		try{
			PreparedStatement psmt = conn.prepareStatement(query);
			psmt.setInt(1, id);
			psmt.executeUpdate();
		}catch(SQLException ex){
			ex.printStackTrace();
		}
		
		return true;
	}
	
	public boolean updateAuthor(Author author){
		String query = "UPDATE Author SET firstname=?, surname=? WHERE idAuthor=?";
		
		try{
			PreparedStatement psmt = conn.prepareStatement(query);
			psmt.setString(1, author.getFirstname());
			psmt.setString(2, author.getSurname());
			psmt.setLong(3, author.getIdAuthor());
			psmt.executeUpdate();
		}catch(SQLException ex){
			ex.printStackTrace();
		}
		
		return true;
	}
}
