package com.bookcollector.model.dao;

import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.ArrayList;

import com.bookcollector.model.Category;
import com.bookcollector.tool.ConnectionManager;

public class CategoryDAO {
	Connection conn = ConnectionManager.getConnection();
	
	public Category getCategory(int idCategory){
		
		String query = "SELECT * FROM Category WHERE idCategory=?";
		Category category = null;
		
		try {
			PreparedStatement psmt = conn.prepareStatement(query);
			psmt.setInt(1, idCategory);
			ResultSet rs = psmt.executeQuery();
			while(rs.next()){
				category = new Category(idCategory, rs.getString("name"));
			}
		} catch (SQLException ex) {
			ex.printStackTrace();
		}
		return category;
	}
	
	public boolean addCategory(String name){
		String query = "INSERT INTO Category VALUES (DEFAULT,?)";
		
		try{
			PreparedStatement psmt = conn.prepareStatement(query);
			psmt.setString(1, name);
			psmt.executeUpdate();
		}catch(SQLException ex){
			ex.printStackTrace();
		}
		
		return true;
	}
	
	public ArrayList<Category> getAllCategories(){
		ArrayList<Category> categories = new ArrayList<>();
		
		String query = "SELECT * FROM Category";
		
		try {
			PreparedStatement psmt = conn.prepareStatement(query);
			ResultSet rs = psmt.executeQuery();
			while(rs.next()){
				Category category = new CategoryDAO().getCategory(rs.getInt("idCategory"));
				categories.add(category);
			}
		} catch (SQLException ex) {
			ex.printStackTrace();
		}
		return categories;
	}
	
	public boolean deleteCategory(int id){
		String query = "DELETE FROM Category WHERE idCategory=?";
		
		try{
			PreparedStatement psmt = conn.prepareStatement(query);
			psmt.setInt(1, id);
			psmt.executeUpdate();
		}catch(SQLException ex){
			ex.printStackTrace();
		}
		
		return true;
	}

	public boolean updateCategory(Category category) {
		String query = "UPDATE Category SET name=? WHERE idCategory=?";
		
		try{
			PreparedStatement psmt = conn.prepareStatement(query);
			psmt.setString(1, category.getName());
			psmt.setInt(2, category.getIdCategory());
			psmt.executeUpdate();
		}catch(SQLException ex){
			ex.printStackTrace();
		}
		
		return true;
	}
}
