package com.bookcollector.model.dao;

import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.ArrayList;

import com.bookcollector.model.Publisher;
import com.bookcollector.tool.ConnectionManager;

public class PublisherDAO {
	
	Connection conn = ConnectionManager.getConnection();
	
	public Publisher getPublisher(int idPublisher){		
		String query = "SELECT * FROM Publisher WHERE idPublisher=?";
		Publisher publisher = null;
		
		try {
			PreparedStatement psmt = conn.prepareStatement(query);
			psmt.setInt(1, idPublisher);
			ResultSet rs = psmt.executeQuery();
			while(rs.next()){
				publisher = new Publisher(idPublisher, rs.getString("name"));
			}
		} catch (SQLException ex) {
			ex.printStackTrace();
		}
		return publisher;
	}
	
	public boolean addPublisher(String name){
		String query = "INSERT INTO Publisher VALUES (DEFAULT,?)";
		
		try{
			PreparedStatement psmt = conn.prepareStatement(query);
			psmt.setString(1, name);
			psmt.executeUpdate();
		}catch(SQLException ex){
			ex.printStackTrace();
		}
		
		return true;
	}
	
	public ArrayList<Publisher> getAllPublishers(){
		ArrayList<Publisher> publishers = new ArrayList<>();
		
		String query = "SELECT * FROM Publisher";
		
		try {
			PreparedStatement psmt = conn.prepareStatement(query);
			ResultSet rs = psmt.executeQuery();
			while(rs.next()){
				Publisher publisher = new PublisherDAO().getPublisher(rs.getInt("idPublisher"));
				publishers.add(publisher);
			}
		} catch (SQLException ex) {
			ex.printStackTrace();
		}
		return publishers;
	}
	
	public boolean deletePublisher(int id){
		String query = "DELETE FROM Publisher WHERE idPublisher=?";
		
		try{
			PreparedStatement psmt = conn.prepareStatement(query);
			psmt.setInt(1, id);
			psmt.executeUpdate();
		}catch(SQLException ex){
			ex.printStackTrace();
		}
		
		return true;
	}

	public boolean updatePublisher(Publisher publisher) {
		String query = "UPDATE Publisher SET name=? WHERE idPublisher=?";
		
		try{
			PreparedStatement psmt = conn.prepareStatement(query);
			psmt.setString(1, publisher.getName());
			psmt.setInt(2, publisher.getIdPublisher());
			psmt.executeUpdate();
		}catch(SQLException ex){
			ex.printStackTrace();
		}
		
		return true;
	}
}
